#include "adplug.h"
#include "paradlib.h"
#include <sched.h>
#include <signal.h>

static int g_mustrun=1;

void sig_handler(int s)
{
	g_mustrun = 0;
}

int main(int argc, char **argv)
{
	struct sched_param sp;
	char *filename;

	signal(SIGINT, sig_handler);
	
	if (argc<2) { 
		printf("Usage: ./paradlib file\n");
		return 1;
	}

	filename = argv[1];
	
	CParadlib *opl = new CParadlib("/dev/parport0");
	opl->init();
	if (opl->isInit()!=0) {
		printf("Failed to init\n");
		return 0;
	}
	CPlayer *p = CAdPlug::factory(filename, opl);

	if (!p) {
		fprintf(stderr, "Error\n");
		return 1;
	}

//	sp.sched_priority = 15;
//	if (sched_setscheduler(0, SCHED_FIFO, &sp)<0) {
//		perror("SCHED_FIFO");
//	}
	
#define USE_SELECT
//#define USE_NANOSLEEP
	while (g_mustrun)
	{
		float t = p->getrefresh();
		int slp = (int)((1.0/t)*1000000.0);
		struct timespec dl;

//		printf("%f -> %d\n", t, slp);
		if (slp<1000000) {
#ifdef USE_NANOSLEEP
			dl.tv_sec = 0;
			dl.tv_nsec = slp*1000;
			nanosleep(&dl, NULL);
			#endif
#ifdef USE_SELECT
			struct timeval tv;
			tv.tv_sec = 0;
			tv.tv_usec = slp;
			select(0, NULL, NULL, NULL, &tv);
#endif
//			printf(","); fflush(stdout);
		}
		else {
			usleep( slp );
			printf("."); fflush(stdout);
		}

		if (!p->update()) {
			g_mustrun = 0;
			printf("end\n");
		}
//		printf(",\n");
	};

	opl->reset_card();
	
	return 0;
}
